<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { SlpPlayIcon, SolutionsVideoModal } from '../solutions/index.vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

interface Video {
  image: string;
  title?: string;
  url: string;
}

interface HeroButton {
  text: string;
  href: string;
  variant?: string;
  icon?: {
    name: string;
    variant: string;
    size?: string;
  };
}

export default Vue.extend({
  components: {
    SolutionsVideoModal,
    SlpPlayIcon,
  },
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    header: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: true,
    },
    video: {
      type: Object as PropType<Video>,
      required: true,
    },
    primaryButton: {
      type: Object as PropType<HeroButton>,
      required: true,
    },
    largeText: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="hero-wrapper">
    <SlpContainer>
      <div class="why-hero">
        <div class="header">
          <SlpTypography variant="heading1-bold" tag="h1">
            {{ header }}
          </SlpTypography>
          <SlpTypography
            :variant="largeText ? 'heading4' : 'body1'"
            :tag="largeText ? 'h1' : 'p'"
          >
            {{ description }}
          </SlpTypography>
          <div class="cta">
            <SlpButton
              variant="primary"
              class="primary"
              :href="primaryButton.href"
              data-ga-name="free trial"
              data-ga-location="Hero"
            >
              {{ primaryButton.text }}</SlpButton
            >
          </div>
        </div>
        <div class="video">
          <div class="image__container" @click="openModal">
            <img :src="video.image" :alt="video.title" />
            <div class="image__container--play">
              <SlpPlayIcon />
            </div>
          </div>
        </div>
      </div>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <iframe
          width="560"
          height="315"
          :src="createVideoSource(video.url)"
          :title="video.title ?? 'Video player'"
          frameborder="0"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
          allowfullscreen
        ></iframe>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.hero-wrapper {
  padding-bottom: 48px;
  overflow: hidden;
  @media (max-width: $breakpoint-md) {
    padding-bottom: 32px;
  }
}

.why-hero {
  padding-top: 115px;
  display: flex;
  align-items: center;
  gap: 64px;
  @media (max-width: $breakpoint-md) {
    padding-top: 64px;
    flex-direction: column;
  }
  .header {
    margin-bottom: 86px;
    display: flex;
    flex-direction: column;
    gap: 24px;
    .cta {
      display: flex;
      gap: 16px;
      flex-direction: column;
      align-items: center;

      @media (min-width: $breakpoint-lg) {
        flex-direction: row;
      }
      .primary,
      .secondary {
        @media (max-width: $breakpoint-lg) {
          width: 100%;
          justify-content: center;
        }
      }
      .secondary {
        @media (max-width: $breakpoint-lg) {
          padding-left: 16px;
        }
      }
    }
    @media (max-width: $breakpoint-md) {
      margin-bottom: 32px;
    }
  }
  .video {
    position: relative;
    &::after {
      position: absolute;
      content: '';
      z-index: -1;
      bottom: -20%;
      right: 0;
      left: 15%;
      height: 135%;
      width: 44vw;
      background: $color-surface-800;
      @media (max-width: $breakpoint-lg) {
        width: 100vw;
        left: -4vw;
      }
    }
  }
}

.image__container {
  position: relative;

  cursor: pointer;
  &:hover {
    .image__container--play {
      opacity: 1;
    }
  }

  &--play {
    position: absolute;
    top: 40%;
    right: 45%;
    opacity: 0.75;
    transition: all 0.3s;
  }
  img {
    border-radius: 4px 4px 90px 4px;
    width: 540px;
    object-fit: cover;
    min-height: 322px;
    @media (max-width: $breakpoint-md) {
      width: 100%;
      min-height: initial;
    }
    border-bottom: 1px solid $color-surface-200;
  }
}
</style>
